package cn.gov.customs.wxjy.task.service.impl;

import cn.gov.customs.cacp.sdks.core.user.trans.CacpTransUser;
import cn.gov.customs.wxjy.common.exception.ServiceException;
import cn.gov.customs.wxjy.common.utils.StringUtils;
import cn.gov.customs.wxjy.common.utils.bean.BeanValidators;
import cn.gov.customs.wxjy.common.utils.uuid.SnowflakeIdWorker;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import javax.validation.Validator;
import java.util.List;
import org.apache.commons.collections4.CollectionUtils;
import cn.gov.customs.wxjy.common.utils.DateUtils;
import com.github.pagehelper.PageInfo;
import cn.gov.customs.wxjy.task.dao.SyncDataStatusMapper;
import cn.gov.customs.wxjy.task.pojo.SyncDataStatus;
import cn.gov.customs.wxjy.task.pojo.SyncDataStatusQuery;
import cn.gov.customs.wxjy.task.service.ISyncDataStatusService;

/**
 * 数据同步状态记录Service业务层处理
 *
 * @author xiong
 * @date 2025-12-19
 */
@Service
@Slf4j
@RequiredArgsConstructor
public class SyncDataStatusServiceImpl implements ISyncDataStatusService {

    private final SyncDataStatusMapper syncDataStatusMapper;

    private final Validator validator;

    /**
     * 查询数据同步状态记录
     *
     * @param ID 数据同步状态记录主键
     * @return 数据同步状态记录
     */
    @Override
    public SyncDataStatus selectByID(String ID) {
        return syncDataStatusMapper.selectByID(ID);
    }

    /**
     * 分页查询数据同步状态记录列表
     *
     * @param query
     * @return 数据同步状态记录
     */
    @Override
    public PageInfo<SyncDataStatus> selectPageList(SyncDataStatusQuery query) {
        return PageInfo.of(syncDataStatusMapper.selectList(query));
    }

    /**
     * 查询数据同步状态记录列表
     *
     * @param query
     * @return 数据同步状态记录
     */
    @Override
    public List<SyncDataStatus> selectList(SyncDataStatusQuery query) {
        return syncDataStatusMapper.selectList(query);
    }

    /**
     * 新增数据同步状态记录
     *
     * @param syncDataStatus 数据同步状态记录
     * @return 结果
     */
    @Override
    public int insert(SyncDataStatus syncDataStatus) {
            return syncDataStatusMapper.insert(syncDataStatus);
    }

    /**
     * 修改数据同步状态记录
     *
     * @param syncDataStatus 数据同步状态记录
     * @return 结果
     */
    @Override
    public int update(SyncDataStatus syncDataStatus) {
        return syncDataStatusMapper.update(syncDataStatus);
    }

    /**
     * 批量删除数据同步状态记录
     *
     * @param ids 需要删除的数据同步状态记录主键
     * @return 结果
     */
    @Override
    public int deleteByIDs(String[] ids) {
        return syncDataStatusMapper.deleteByIDs(ids);
    }

    /**
     * 删除数据同步状态记录信息
     *
     * @param ID 数据同步状态记录主键
     * @return 结果
     */
    @Override
    public int deleteByID(String ID) {
        return syncDataStatusMapper.deleteByID(ID);
    }

    /**
     * 逻辑删除数据同步状态记录信息
     *
     * @param ID 数据同步状态记录主键
     * @return 结果
     */
    @Override
    public int logicDelete(String ID) {

        return syncDataStatusMapper.logicDelete(ID);
    }

    /**
     * 导入数据同步状态记录数据
     *
     * @param syncDataStatusList 数据同步状态记录数据列表
     * @param isUpdateSupport 是否更新支持，如果已存在，则进行更新数据
     * @param cacpTransUser 操作用户
     * @return 结果
     */
    @Override
    public String importSyncDataStatus(List<SyncDataStatus> syncDataStatusList, Boolean isUpdateSupport, CacpTransUser cacpTransUser) {
        if (CollectionUtils.isEmpty(syncDataStatusList)) {
            throw new ServiceException("导入数据不能为空！");
        }
        int successNum = 0;
        int failureNum = 0;
        StringBuilder successMsg = new StringBuilder();
        StringBuilder failureMsg = new StringBuilder();
        for (SyncDataStatus syncDataStatus : syncDataStatusList) {
            try {

                BeanValidators.validateWithException(validator, syncDataStatus);
                //id名称不统一，自行处理
                syncDataStatus.setCreateTime(DateUtils.getNowDate());
                syncDataStatus.setUpdateTime(DateUtils.getNowDate());
                syncDataStatus.setCreateUser(cacpTransUser.getUserId());
                syncDataStatus.setCreateDept(cacpTransUser.getParentGuid());

                syncDataStatusMapper.insert(syncDataStatus);
                successNum++;
                successMsg.append("<br/>" + successNum + "、 " + cacpTransUser.getUserName() + " 导入成功");

            } catch (Exception e) {
                failureNum++;
                String msg = "<br/>" + failureNum + "、" + cacpTransUser.getUserName() + " 导入失败：";
                failureMsg.append(msg + e.getMessage());
                log.error(msg, e);
            }
        }
        if (failureNum > 0) {
            failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
            throw new ServiceException(failureMsg.toString());
        } else {
            successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
        }
        return successMsg.toString();
    }
}
